﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using NUnit.Framework;

using Siemens.Automation.OMSPlus.Test.OMSp_Managed_HelpLib;


namespace NunitTest
{
	/// <summary>
	/// the main class for all tests
	/// </summary>
	public class BaseFuncCls
	{

		#region variables

		// watchdog
		WatchDog m_WatchDog = null;

		// error 
		CheckErrors m_checkErrors = null;

		#endregion variables


		#region init

		/// <summary>
		/// ctor
		/// </summary>
		/// <param name="curWatchDog"></param>
		/// <param name="curCheckErrors"></param>
		public void initBaseFuncCls(WatchDog curWatchDog, CheckErrors curCheckErrors)
		{
			m_checkErrors = curCheckErrors;
			m_WatchDog = curWatchDog;
		}

		#endregion ctor


		#region start

		public void RunBeforeTestCase()
		{
		}

		public void RunBeforeScenario()
		{
		}

		#endregion start


		#region end

		public void RunAfterTestCase()
		{
		}

		public void RunAfterScenario()
		{
		}
		#endregion end


		#region test

		public void A_download_tree1()
		{
			Console.WriteLine("A_download_tree1() - start");
			System.Threading.Thread.Sleep(1000);
			saveCurrentError("A_download_tree1", "s jetoj oshibkoj zhit mozhno...", 25, null, false);
			saveCurrentError("A_download_tree1", "Test UMER...", 15, null, true);
			Console.WriteLine("A_download_tree1() - end");
		}

		public void A_download_tree2()
		{
			Console.WriteLine("A_download_tree2() - start");
			//System.Threading.Thread.Sleep(3000);

			try
			{
				int n = 0;
				int m = 5 / n;
			}
			catch(Exception excep)
			{
				saveCurrentError("A_download_tree2", "Test UPAL v catch()...", 0, excep, true);
			}

			Console.WriteLine("A_download_tree2() - end");
		}


		#endregion test


		#region error


		public void saveCurrentError(string sFuncName, string sErrorMessage, int nErrorCode,
														Exception curException, bool bMustBeStopped)
		{
			m_checkErrors.addError(sFuncName, sErrorMessage, nErrorCode, curException);

			if (bMustBeStopped)
			{				
				System.Threading.Thread.Sleep(m_WatchDog.EventTimeout);
			}
		}


		#endregion error

	}
}
