﻿
#region namespaces

using System;
using System.Collections.Generic;

using System.Linq;
using System.Text;
using System.Collections;


using Siemens.Automation.OMSPlus.Test.OMSp_Managed_HelpLib;


#endregion namespaces

namespace NunitTest
{
	public class CheckErrors
	{
		struct ErrorInfos
		{
			// name of the failed function
			public string m_sFuncName;	

			// error message
			public string m_sErrorMessage;

			// error code (if exists)
			public int m_nErrorCode;

			// exception (if exists)
			public Exception m_exception;
		};


		#region variables

		// all errors
		ArrayList m_allErrors = new ArrayList();


		#endregion variables


		#region ctor

		/// <summary>
		/// ctor
		/// </summary>
		public CheckErrors()
		{
		}

		#endregion ctor


		#region get / set one error

		/// <summary>
		/// add error infos in the list m_allErrors
		/// </summary>
		/// <param name="sFuncName"></param>
		/// <param name="sErrorMessage"></param>
		/// <param name="nErrorCode"></param>
		/// <param name="curException"></param>
		public void addError( string sFuncName, string sErrorMessage, int nErrorCode, 
													Exception curException)
		{
			ErrorInfos curErrorInfo = new ErrorInfos();
			curErrorInfo.m_exception = curException;
			curErrorInfo.m_nErrorCode = nErrorCode;
			curErrorInfo.m_sErrorMessage = sErrorMessage;
			curErrorInfo.m_sFuncName = sFuncName;

			m_allErrors.Add(curErrorInfo);
		}


		/// <summary>
		/// get one error from the list m_allErrors
		/// </summary>
		/// <param name="sFuncName"></param>
		/// <param name="sErrorMessage"></param>
		/// <param name="nErrorCode"></param>
		/// <param name="curException"></param>
		/// <param name="nIndex"></param>
		public void getOneError(ref string sFuncName, ref string sErrorMessage, ref int nErrorCode, 
														ref Exception curException, int nIndex)
		{
			sFuncName = "";
			sErrorMessage = "";
			nErrorCode = 0;
			curException = null;

			if (m_allErrors != null && nIndex < m_allErrors.Count)
			{
				ErrorInfos oneError = (ErrorInfos)m_allErrors[nIndex];
				sFuncName = oneError.m_sFuncName;
				sErrorMessage = oneError.m_sErrorMessage;
				nErrorCode = oneError.m_nErrorCode;
				curException = oneError.m_exception;
			}
		}


		/// <summary>
		/// get count of errors in the list m_allErrors
		/// </summary>
		/// <returns></returns>
		public int getErrorCount()
		{
			return m_allErrors.Count;
		}


		#endregion get / set one error

	}
}
